//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	AbstractBasicSkills.cpp
 *  \brief implementacia metod tried CAbstractBasicSkills, CAbstractBasicSkillsList, CCatch, CDribble
 *  \author Rado Otipka 
 *  \date 4. 12. 2001 21:49:11
 *  \version 
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++


#include "stdafx.h"
#include "player.h"
#include "AbstractBasicSkills.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

/////////////////////////////////////CAbstractBasicSkills/////////////////////////

CAbstractBasicSkills::CAbstractBasicSkills(int skillType, int priority, CLocalAgent *agent) 
{
	m_skillType = skillType;
	m_priority = priority;
	m_agent = agent;
};

CAbstractBasicSkills::~CAbstractBasicSkills()
{
};

CAbstractBasicSkills::CAbstractBasicSkills(const CAbstractBasicSkills &skill) 
{
	m_skillType = skill.m_skillType;
	m_priority = skill.m_priority;
	m_agent = skill.m_agent;
	m_accel = skill.m_accel;
	m_power = skill.m_power;
	m_dir = skill.m_dir;
	m_moment = skill.m_moment;
	m_pos = skill.m_pos;
	m_skillSkillType = skill.m_skillSkillType;
}

CAbstractBasicSkills::operator=(CAbstractBasicSkills &skill) 
{
	m_skillType = skill.GetSkillType();
	m_priority = skill.GetPriority();
	m_agent = skill.GetAgent();
	m_accel = skill.m_accel;
	m_power = skill.m_power;
	m_dir = skill.m_dir;
	m_moment = skill.m_moment;
	m_pos = skill.m_pos;
	m_skillSkillType = skill.m_skillSkillType;
}; 

bool operator<(CAbstractBasicSkills  &lhs, CAbstractBasicSkills &rhs) 
{
	return(lhs.GetPriority() < rhs.GetPriority());
};

bool operator==( CAbstractBasicSkills  &lhs,  CAbstractBasicSkills &rhs) 
{
	return(lhs.GetPriority() == rhs.GetPriority());
};

bool operator<=( CAbstractBasicSkills  &lhs,  CAbstractBasicSkills &rhs) 
{
	return(lhs.GetPriority() == rhs.GetPriority());
};

void CAbstractBasicSkills::Execute()
{
};

///////////////////////////CAbstractBasicSkillsList////////////////////////////////



//------------------------------------------------------
/*! \fn	void CAbstractBasicSkillsList::EvaluateAndRemove() 
 *  \brief Vyhodnoti zakladnu schopnost s najvysou prioritou
 *  \return
 *  \author Rado Otipka
 *  \date 3. 12. 2001 20:20:22

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
void CAbstractBasicSkillsList::EvaluateAndRemove() 
{
	if(!IsEmpty()) {
		int tmp =-1;
		int index = 0;
		for( int i =0;i<m_skillsList.GetSize();i++) {
			if( m_skillsList[i]->GetPriority() > tmp) {
				tmp = m_skillsList[i]->GetPriority();
				index = i;
			}
		}
		switch( m_skillsList[index]->GetSkillType() ) {
		case BSKILL_KICK: (((CKick *) m_skillsList[index]))->Execute();
			break;
		case BSKILL_MOVE: ((CMove *) m_skillsList[index])->Execute();	
			break;
		case BSKILL_TURN: (((CTurn *) m_skillsList[index]))->Execute();
			break;
		case BSKILL_CATCH: (((CCatch *) m_skillsList[index]))->Execute();
			break; 	
		case BSKILL_DRIBBLE: (((CDribble *) m_skillsList[index]))->Execute();	
			break; 	
		case BSKILL_TURN_NECK: (((CTurnNeck *) m_skillsList[index]))->Execute();
			break;
		case BSKILL_PASS: (((CPass *) m_skillsList[index]))->Execute();
			break;
		case BSKILL_MANAGE:  
			switch( (((CManage *) m_skillsList[index]))->GetSkillSkillType() ) {
			case BSKILL_MANAGE_REMOVEALL: Empty(); 
				return;	
			}
			break;
		}
		if(m_skillsList[index] != NULL) { 
			delete m_skillsList[index];
			m_skillsList[index] =NULL;
		}
		m_skillsList.RemoveAt(index);
	}		
};


void CAbstractBasicSkillsList::Empty() 
{
	for( int i = 0; i<m_skillsList.GetSize(); i++ ) {
		delete m_skillsList[i];
	}
	m_skillsList.RemoveAll();
}

CAbstractBasicSkillsList::CAbstractBasicSkillsList() {};

////////////////////////////////CCatch/////////////////////////////////////////////

//------------------------------------------------------
/*! \fn	void CCatch::Catch( double dir )
 *  \brief chytenie lopty do ruk
 *  \param  double dir
 *  \return
 *  \author Rado Kostelnik
 *  \date 3. 12. 2001 20:21:49

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
void CCatch::Catch( C2DVector ballPos)
{
	if( m_localSituation->BallCatchable(GetAgent()) )
	{
		C2DVector toball = m_localSituation->RelVectorTo( GetAgent(), ballPos );
		CGameCommand *pGameCommand = new CGameCommand();
		pGameCommand->Catch(RadToDeg(AngNormalise(toball.GetAngle())));
		GetAgent()->actionseq->AddGameCommand(pGameCommand);
	}
}

CCatch::CCatch( TParamVector &parameter, CLocalAgent *pl, int priority ) 
{
	double m_accel = 0, posX = 0, posY = 0;
	m_accel = 0;
	TParamVectorIterator index = parameter.begin();
	for( ; index != parameter.end(); index++ ) {
		if( index->name == VALUE_ANGLE )
				sscanf( index->value.data(), "%d", &m_dir );
		if( index->name == VALUE_X ) 
				sscanf( index->value.data(), "%lf", &posX ); 				
		if( index->name == VALUE_Y ) 
				sscanf( index->value.data(), "%lf", &posY );
		if( index->name == VALUE_TYPE )
				sscanf( index->value.data(), "%d", &m_skillSkillType );			
	}
	m_pos = C2DVector( posX, posY );	
}

void CCatch::Execute() 
{
	switch( m_skillSkillType ) {
	case BSKILL_CATCH_BASIC: Catch( m_pos );
		break;
	}

}


////////////////////////////////CDribble/////////////////////////////////////////////

CDribble::CDribble( TParamVector &parameter, CLocalAgent *pl, int priority ):CAbstractBasicSkills( BSKILL_DRIBBLE, priority, pl ) 
{
	double posX = 0, posY = 0; m_accel = 0;
	m_accel = 0;
	TParamVectorIterator index = parameter.begin();
	for( ; index != parameter.end(); index++ ) {
		if( index->name == VALUE_X ) 
				sscanf( index->value.data(), "%lf", &posX ); 				
		if( index->name == VALUE_Y ) 
				sscanf( index->value.data(), "%lf", &posY );
		if( index->name == VALUE_ACCEL )
				sscanf( index->value.data(), "%lf", &m_accel );
		if( index->name == VALUE_TYPE )
				sscanf( index->value.data(), "%d", &m_skillSkillType );			
	}
	m_pos = C2DVector( posX, posY );
}


//------------------------------------------------------
/*! \fn	void CDribble::Execute()
 *  \brief vykonanie zakladnej schopnosti
 *  \param <name> <description>
 *  \return
 *  \author Rado Otipka 
 *  \date 3. 12. 2001 20:01:52

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
void CDribble::Execute()
{
	switch( m_skillSkillType ) {
		case BSKILL_DRIBLE_SMART:  
			SmartDrible( m_pos, m_accel );
			break;
	}
};

//------------------------------------------------------
/*! \fn	void CDribble::SmartDrible( C2DVector destPos, double accel) 
 *  \brief vedenie lopty na urcenu poziciu, 
 *  \param C2DVector destPos konecna pozicia 
 *  \param double accel zrychlenie
 *  \return
 *  \author Rado Otipka 
 *  \date 3. 12. 2001 19:38:14
 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
void CDribble::SmartDrible( C2DVector destPos, double accel) 
{
	C2DVector topos = m_localSituation->RelVectorTo(GetAgent(), destPos);
	//C2DVector vBall = GetAgent()->GetWorldModel()->GetBall()->GetSpeed();
	//C2DVector vPa  = GetAgent()->GetSpeed();
	//topos.GetAngle
	//C2DVector  final = vBall + vPa;
	C2DVector ballPos = GetAgent()->GetWorldModel()->GetBall()->GetPosition();
	C2DVector agentPos = GetAgent()->GetPosition();
    if (m_localSituation->BallKickable(GetAgent())) {
		if( (destPos - agentPos).GetDistance() < (destPos - ballPos).GetDistance() ) {
////////////////testovanie tych parametrov/////////
			CKick(BSKILL_KICK_WITH_ACCEL_BYPASS, accel, destPos ,GetAgent(),0).Execute();
		} else {
			CKick(BSKILL_KICK_WITH_ACCEL_BYPASS, accel, destPos ,GetAgent(),0).Execute();
		}
		if( topos.GetAngle() > 5 || topos.GetAngle() <5 )
			GetAgent()->listSkl->AddSkill(new CTurn( BSKILL_TURN_2,topos.GetAngle(),GetAgent(),101 ));

		GetAgent()->listSkl->AddSkill(new CMove( BSKILL_MOVE_DASH , accel ,GetAgent(),101));	
    } else {
		CMove( BSKILL_MOVE_GOTO ,ballPos,100,GetAgent(),0).Execute();	
     }
//	if( (destPos - GetAgent()->GetPosition()).GetDistance() > 2 ) 
//		GetAgent()->listSkl->AddSkill( new CDribble( BSKILL_DRIBLE_SMART, destPos,accel, GetAgent(), 99 ) );
};


////////////////////////////////CPas/////////////////////////////////////////////

CPass::CPass( TParamVector &parameter, CLocalAgent *pl, int priority ):CAbstractBasicSkills( BSKILL_PASS, priority, pl ) 
{
	m_playerNumber = pl->GetPlayerNumber();
	TParamVectorIterator index = parameter.begin();
	for( ; index != parameter.end(); index++ ) {
		if( index->name == VALUE_PLAYER ) 
				sscanf( index->value.data(), "%lf", &m_playerNumber ); 				
		if( index->name == VALUE_TYPE )
				sscanf( index->value.data(), "%d", &m_skillSkillType );			
	}
}

void CPass::Execute() 
{
	switch( m_skillSkillType ) {
	case BSKILL_PASS_TO:  
			PassToPlayer( m_playerNumber );
			break;
	}
}

//------------------------------------------------------
/*! \fn	void CPass::PassToPlayer( int number ) 
 *  \brief Jednoducha prihravka, pricom zatial neberiem do uvahy rychlost hraca a ani rychlost pohybujucej sa lopty
 *  \brief !este som to netestoval!
 *  \param  int number
 *  \return
 *  \author Rado Otipka 
 *  \date 5. 12. 2001 8:44:02

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
void CPass::PassToPlayer( int number ) 
{
   if( number == GetAgent()->GetPlayerNumber() ) return; //mam nahrat sam sebe ?
   C2DVector posAgent(0,0);
   int agentsCount = GetAgent()->GetWorldModel()->GetIdentifiedAgentsCount();
   ESide tMySide = GetAgent()->GetPlayerSide();
   for(int i=0; i < agentsCount; i++) {
		CAgent *agent = GetAgent()->GetWorldModel()->GetIdentifiedAgent(i);
		if( agent->GetPlayerSide() == tMySide ) {
			if( agent->GetPlayerNumber() == number ) {
				posAgent = agent->GetPosition();
			}
		}
   }
   if( i == agentsCount ) return; //svojho agenta s takym cislom nevidim 
   else  {
	  CKick(BSKILL_KICK_TO_POSITION, 0, posAgent ,GetAgent(),0).Execute();
   }
}