//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*! \file	AbstractBasicSkills.h
 *  \brief Deklaracia tried implementujucich zakladne schopnosti
 *  \author Rado Otipka
 *  \date 2. 12. 2001 15:23:28
 *  \version 2.52.1
 *  \bug 
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
// Historia zmien:
//++++++++++++++++++++++++++++++++++++++++++++++++++++++
/*
 */
//++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef ABSTRACTBASICSKILLS_H
#define ABSTRACTBASICSKILLS_H
#pragma warning (disable:4786)

#include "GameCommand.h"
#include "WorldGeometry.h"
#include "worldobjects.h"
#include <afxtempl.h>
#include <string>
#include <vector>
#include <comdef.h>
#include <iostream>
/*Vysvetlivky:

"define zakladnej schopnosti" //"parametre zakladnej schopnosti"//"blisi popis zakl. schopnosti" - uvadzam iba pri niektorych schopnostiach

*/
#define BSKILL_KICK			100     
	#define BSKILL_KICK_WITH_POWER 101 //smer - double, sila kopu - double 
	#define BSKILL_KICK_WITH_ACCEL 102  //smer - double, akceleracia(zrychlenie) - double 
	#define BSKILL_KICK_WITH_ACCEL_BYPASS 103 // pozicia -  C2DVector, akceleracia(zrychlenie) - double //taky kop aby som netrafil hraca v smere kopu
	#define BSKILL_KICK_TO_POSITION 104 //  pozicia - C2DVector, akceleracia(zrychlenie) -double
	#define BSKILL_KICK_GOAL 105		//bez parametra
	#define BSKILL_KICK_FRIENDKICK 106  //bez parametra, to ktoremu spoluhracovi ma nahrat, si vypocita sam
	
#define BSKILL_MOVE  200
	#define BSKILL_MOVE_DASH 201     //power - double// elementarny pohyb vpred
	#define BSKILL_MOVE_GOTO 202	 //pozicia - C2DVector , zrychlenie - double 
	#define BSKILL_MOVE_FACETOGO 203 //pohybujuci sa objekt - CMovingObject *, pozicia(kam sa ma hrac dostat) - C2DVector, zrychlenie -double//beh na urcenu poziciu, pricom sa pozeram, stale na urcity objekt 
	#define BSKILL_MOVE_TO 204		 //pozicia - C2DVector alebo suradnice x,y //hrac sa nastvy na urcenu, poziciu 
	#define BSKILL_MOVE_GOTO_PLAYER 205 //chod k hracovy

#define BSKILL_TURN				300 
	#define BSKILL_TURN_ME		301 //moment - double
	#define BSKILL_TURN_TO		302 //pozicia - C2DVector
	#define BSKILL_TURN_2		303    //uhol otocenia - double 

#define BSKILL_CATCH	400
	#define BSKILL_CATCH_BASIC 401	//direction(smer) - double

//este nie je hotove
#define BSKILL_DRIBBLE	500
	#define BSKILL_DRIBLE_SMART 501 //pozicia - C2DVector, zrychlenie - double

#define BSKILL_MANAGE 600
	#define BSKILL_MANAGE_REMOVEALL 601 //bez parametrov, vymaze vsetky prvky v zoznam schopnosti

#define BSKILL_TURN_NECK   700  
	#define BSKILL_TURN_NECK_BASIC 701 //moment - double
	#define BSKILL_TURN_NECK_TO	702 //pozicia - C2DVector
	#define BSKILL_TURN_NECK_STRAIGHT	703 //bez parametrov//otocenie hlavy dopradu
	#define BSKILL_TURN_NECK_TO_BALL	 704 //bez parametrov//otocenie sa za loptou

#define BSKILL_PASS   800  
	#define BSKILL_PASS_TO  801

////////////////////////Definovanie Priorit//////////////////////
#define DEFAULT_PRIORITY 100
//////////////////////////////////////////////////////////
#define DEFINE_LIMIT 100
//////////////////////////////////////////////////////////
#define  MAX_DISTANCE   999999.99
#define  MAXNTESTDIR 16
//////////////////////////////////////////////////////////

#define VALUE_X		 "x"
#define VALUE_Y		 "y"
#define VALUE_ACCEL  "accel" //zrychlenie, nemusis uvadzat 
#define VALUE_TYPE   "type"  //typ cinnosti
#define VALUE_ANGLE  "angle"
#define VALUE_PLAYER "player" //cislo hraca

///////////////ZHRNUTIE POUZIVANYCH ZAKLADNYCH SCHOPNOSTI//////////
/* parametre uvedene v hranatych zatvorkach nie je povinne uvadzat
1. Kop na poziciu, CKick, VALUE_TYPE = BSKILL_KICK_TO_POSITION, VALUE_X = x, VALUE_Y = y, [VALUE_ACCEL = zrychlenie]
2. Chod na poziciu, CMove,  VALUE_TYPE = BSKILL_MOVE_GOTO, VALUE_X = x, VALUE_Y = y, [VALUE_ACCEL = zrychlenie]
3. Chod k hracovi,  CMove,  VALUE_TYPE = BSKILL_MOVE_GOTO_PLAYER, VALUE_PLAYER = cislo hraca
4. Prihraj hracovy,  CPass,   VALUE_TYPE = BSKILL_PASS_TO, VALUE_PLAYER = cislo hraca
5. Dribluj na poziciu, CDrible,  VALUE_TYPE = BSKILL_DRIBLE_SMART, VALUE_X = x, VALUE_Y = y, [VALUE_ACCEL = zrychlenie]
6. Chyt loptu do ruk, CCatch,  VALUE_TYPE = BSKILL_CATCH_BASIC, VALUE_X = x_poziciaLopty, VALUE_Y = y_poziciaLopty
7. Otoc sa na poziciu, CTurn, VALUE_TYPE = BSKILL_TURN_TO, VALUE_X = x, VALUE_Y = y
8. Otoc krk na poziciu, CTurnNeck, VALUE_TYPE = BSKILL_TURN_NECK_TO, VALUE_X = x, VALUE_Y = y
*/
///////////////ZHRNUTIE POUZIVANYCH ZAKLADNYCH SCHOPNOSTI//////////

class CParam
{
public:
	CParam(){};
	CParam( string nameIn, string valueIn ) { name = nameIn; value = valueIn;};
	virtual ~CParam() {};

	void SetParameters( string nameIn, string valueIn ){ name = nameIn; value = valueIn;};
	string GetName() { return name; }
	string GetValue() { return name; }

	string name;
	string value;
};

typedef vector<CParam> TParamVector;
typedef vector<CParam>::iterator TParamVectorIterator;

//zakladne ohodnotenie situacie
class CEstimateLocalSituation 
{
public:
	bool BallKickable(CLocalAgent *pa);
    bool NearGoal(CLocalAgent *pa, EGoalType g);
	double MinimalDirection(CLocalAgent *pa, double dist);
	double DistToClosestOpponent(CLocalAgent *pa, C2DVector cFriendPos);

    CAgent *PlayerInWay(CLocalAgent *pa, double dir);
//    double NearestOpponentToBall(CLocalAgent *pa);
    CAgent *NearestFriendToBall(CLocalAgent *pa);
    CAgent *NearestOpponentToBall(CLocalAgent *pa);
	CAgent *FreestFriend(CLocalAgent *pa);
	C2DVector RelVectorTo(CAgent *pa, C2DVector pos);

    bool BallCatchable(CLocalAgent *pa);
    //! odhad do buducnosti
    C2DVector BallPosition(CLocalAgent *pa, int nTime, C2DVector cNewBallSpeed);
    C2DVector BallPosition(CLocalAgent *pa, int nTime);
    C2DVector GetBallInterceptPosition(CLocalAgent *pa, C2DVector cNewBallSpeed, CAgent *pa2=NULL);
	// added by frz
	CAgent *NearestPlayerToBall(CLocalAgent *pa);  // vrati najblizsieho hraca zo vsekych identifikovanych 
	CAgent *NearestOppPlayer(CLocalAgent* pa);	// vrati najblizsieho protihraca
	CAgent *NearestUnitMemberToPlayer(CLocalAgent* pa, CAgent *a); // vrati najblizsieho clena unitu k danemu protihracovi
	CAgent *NearestFriendToPos(CLocalAgent *pa, C2DVector pos); //vrati nablisieho spoluhraca k danemu miestu
	CAgent *NearestUnitMemberToPos(CLocalAgent* pa, C2DVector pos);  //vrati nablisieho clena unitu k danemu miestu
};


class CAbstractBasicSkills  
{
private:
	int m_skillType, m_priority;
	CLocalAgent *m_agent;
	
public:
	CEstimateLocalSituation	*m_localSituation;
	CAbstractBasicSkills(int skillType, int priority, CLocalAgent *player); 
	CAbstractBasicSkills() {};
	virtual ~CAbstractBasicSkills();
	virtual void Execute();
	void SetSkillType( int type ) {  m_skillType = type; };
	int GetSkillType() {  return m_skillType; }
	int GetSkillSkillType() { return m_skillSkillType; }
	int GetPriority() { return m_priority; }

	void SetAgent( CLocalAgent *agent  ) {  m_agent = agent; }; 
	CLocalAgent *GetAgent() { return m_agent; };
	CAbstractBasicSkills(const CAbstractBasicSkills &skill);
	operator=(CAbstractBasicSkills &skill); 

protected:
	double m_accel, m_power, m_dir, m_moment;
	C2DVector m_pos;
	int m_skillSkillType;
};

bool operator<(CAbstractBasicSkills  &lhs, CAbstractBasicSkills &rhs);
//////////////////////////////////////////////////////////////


class CKick: public CAbstractBasicSkills
{
public:
	CKick( TParamVector &parameter, CLocalAgent *pl, int priority  ) ;
	void Execute();

	CKick( int kickType, double accel, C2DVector pos, CLocalAgent *pl, int priority  ) :CAbstractBasicSkills( BSKILL_KICK, priority, pl ) 
	{
		m_skillSkillType = kickType;
		m_accel = accel;
		m_pos = pos;
	};

private:
	void Kick(  double power, double dir);
	double KickDistance( );
	void Kick2(  double accel, double dir);
	void KickTo(  C2DVector pos, double accel);
	C2DVector KickRealToWanted(  double accel, double dir);
	C2DVector KickWantedToReal(  double accel, double dir);
	void GoalKick();
    void FriendKick();
	void Kick2Bypass(C2DVector pos, double accel);
};


class CMove: public CAbstractBasicSkills
{
private:
	int m_playerNumber;
public:
	CMove( TParamVector &parameter, CLocalAgent *pl, int priority );

	CMove( int moveType, double accel, CLocalAgent *pl, int priority  ) :CAbstractBasicSkills( BSKILL_MOVE, priority, pl ) 
	{
		m_skillSkillType = moveType;
		m_accel = accel;
		m_power = accel;
	};
	CMove( int moveType, C2DVector pos, double accel, CLocalAgent *pl, int priority  ) :CAbstractBasicSkills( BSKILL_MOVE, priority, pl ) 
	{
		m_skillSkillType = moveType;
		m_pos = pos;
		m_accel = accel;
	};

	void Execute();

private:
	void Dash( double power);
	void Move(double x, double y);
	void Move(C2DVector pos);
    void GoTo( C2DVector pos, double accel=0);
    void FaceGoTo( CMovingObject *faceobj, C2DVector pos, double accel=0);
	void Dash2( double accel );
	double DashRealToWanted(double accel);
	void GoToPlayer( int number ); //zatial nefunkcna
	double m_dir,m_x, m_y;
	CMovingObject *m_movObj;
};


class CTurn: public CAbstractBasicSkills
{
private:
	double m_moment;
public:
	CTurn( TParamVector &parameter, CLocalAgent *pl, int priority ) ;

	CTurn( int turnType, double moment, CLocalAgent *pl, int priority  ) :CAbstractBasicSkills( BSKILL_MOVE, priority, pl ) 
	{
		m_skillSkillType = turnType;
		m_moment  = moment;
		
	};
	CTurn( int turnType, C2DVector pos, CLocalAgent *pl, int priority  ) :CAbstractBasicSkills( BSKILL_MOVE, priority, pl ) 
	{
		m_skillSkillType = turnType;
		m_pos = pos;
	};

	void Execute();

private:
	void Turn( double moment);
    double TurnWantedToReal( double angle);
    double TurnRealToWanted(double moment);
	void TurnTo( C2DVector pos);
	void Turn2(double angle);
};


class CTurnNeck: public CAbstractBasicSkills
{
private:
	double m_moment;

public:
	CTurnNeck( TParamVector &parameter, CLocalAgent *pl, int priority ) ;

	CTurnNeck( int turnType, double moment, CLocalAgent *pl, int priority  ) :CAbstractBasicSkills( BSKILL_MOVE, priority, pl ) 
	{
		m_skillSkillType = turnType;
		m_moment  = moment;		
	};

	CTurnNeck( int turnType, C2DVector pos, CLocalAgent *pl, int priority  ) :CAbstractBasicSkills( BSKILL_MOVE, priority, pl ) 
	{
		m_skillSkillType = turnType;
		m_pos = pos;
	};

	void Execute();

private:
    void TurnNeck( double moment );
    void TurnNeckTo( C2DVector pos );
    void TurnNeckToBall();
    void TurnNeckStraight();
};


class CCatch: public CAbstractBasicSkills
{	
public:
	CCatch( TParamVector &parameter, CLocalAgent *pl, int priority );

	CCatch( int catchType, double dir, CLocalAgent *pl, int priority  ) :CAbstractBasicSkills( BSKILL_CATCH, priority, pl ) 
	{
		m_skillSkillType = catchType;
		m_dir = dir;
	};
	void Execute();
private:
	void Catch( C2DVector ballPos);
	
};


class CDribble: public CAbstractBasicSkills 
{
public:
	CDribble( TParamVector &parameter, CLocalAgent *pl, int priority );

	CDribble(int dribleType, C2DVector destPos, double accel , CLocalAgent *pl, int priority  ) :CAbstractBasicSkills( BSKILL_DRIBBLE, priority, pl ) 
	{
		m_skillSkillType = dribleType;
		m_pos = destPos;
		m_accel =accel;
	};
	
	void Execute();

private:
	void SmartDrible( C2DVector destPos, double accel) ;
	void ReverseBall();
};

class CManage: public CAbstractBasicSkills
{
	CManage( TParamVector &parameter, CLocalAgent *pl, int priority );

	CManage(int manageType, CLocalAgent *pl, int priority  ) :CAbstractBasicSkills( BSKILL_MANAGE, priority, pl ) 
	{
		m_skillSkillType = manageType;
	};
	//v tejto triede nebude execute, vyhodnoti ju CAbstractBasicSkillsList, ked sa na nu dostane
};

class CPass: public CAbstractBasicSkills
{
private:
	int m_playerNumber;

public:
	CPass( TParamVector &parameter, CLocalAgent *pl, int priority );
	void Execute();

private:
	void PassToPlayer( int number ); 
};
//////////////////////////////////////////////////////////

class CAbstractBasicSkillsList 
{
private:
	CArray<CAbstractBasicSkills *,CAbstractBasicSkills *> m_skillsList;

public:
	CAbstractBasicSkillsList(); 
	void AddSkill( CAbstractBasicSkills *skills) { m_skillsList.Add( skills ); };
	bool IsEmpty() { return m_skillsList.GetSize()==0; };
	void Empty() ;
	RemoveSkill();
	virtual void EvaluateAndRemove();
};
///////////////////////////////////////////////////////////

#endif //ABSTRACTBASICSKILLS_H