#include "stdafx.h"
//#include "Skills.h"
#include "LogManager.h"
#include "WorldObjects.h"
#include "AbstractBasicSkills.h"

#define POWERRANGE(x)  (((x)>pa->cfg->maxpower)?pa->cfg->maxpower:             \
                        (((x)<pa->cfg->minpower)?pa->cfg->minpower:(x)))
#define MOMENTRANGE(x) (((x)>pa->cfg->maxmoment)?pa->cfg->maxmoment:           \
                        (((x)<pa->cfg->minmoment)?pa->cfg->minmoment:(x)))
#define NECKRANGE(x)   (((x)>pa->cfg->maxneckmoment)?pa->cfg->maxneckmoment:   \
                        (((x)<pa->cfg->minneckmoment)?pa->cfg->minneckmoment:(x)))

#define MINTURN  0.001

// FIXME: pre aku neurcitost sa pozerat za loptou
#define INVALID(diff, dist) ((((dist)>5) && ((diff)>(0.5*(dist)))) || (((dist)<5) && ((diff)>3)))


bool CEstimateLocalSituation::BallKickable(CLocalAgent *pa)
{
    double disttoball = RelVectorTo(pa, pa->GetWorldModel()->GetBall()->GetPosition()).GetDistance();
    double dist = pa->cfg->kickable_area - disttoball;
    if (dist < 0) return false;
    return true;
}

bool CEstimateLocalSituation::NearGoal(CLocalAgent *pa,EGoalType g) 
{
	return false;
}

CAgent *CEstimateLocalSituation::PlayerInWay(CLocalAgent *pa, double dir)
{
    CWorldModel *pwm = pa->GetWorldModel();
    Agents *pia = pwm->GetIdentifiedAgents();
    Agents *pua = pwm->GetUnidentifiedAgents();

    int i;
    C2DVector toplr, toplr2;
    double pldir;
    double pldist, pldist2;
    double mindir;
    CAgent *pnow = NULL;
    CAgent *pret = NULL;

    LOGMSG(1, "search 4 player in way (see total %d players)", pia->size()+pua->size());


    // hladame medzi identifikovanymi hracmi
	for(i=0; i < pia->size(); i++)
	{
        pnow = pia->at(i);
        // vektor na hraca
        toplr = RelVectorTo(pa, pnow->GetPosition());
        pldir = toplr.GetAngle();
        pldist = toplr.GetDistance();
        mindir = MinimalDirection(pa, pldist/*, pnow->GetPosition().GetDiffusion()*/);
//        if ((pldir > -mindir) && (pldir < mindir)) {
        if (fabs(pldir - dir) < mindir) {
            if (pret) {
                toplr2 = RelVectorTo(pa, pret->GetPosition());
                pldist2 = toplr2.GetDistance();
                // vratime toho co je blizsie
                if( pldist < pldist2) pret = pnow;
            }
            else {
                pret = pnow;
            }
        }

        LOGMSG(1, "IDPLAYER %d: dir %lf, dist %lf  (mindir %lf)", i, pldir, pldist, mindir);

    }

    // hladame medzi neidentifikovanymi hracmi
    for(i=0;i<pua->size();i++)
	{
        pnow = pua->at(i);
        // vektor na hraca
        toplr = RelVectorTo(pa, pnow->GetPosition());
        pldir = toplr.GetAngle();
        pldist = toplr.GetDistance();
        mindir = MinimalDirection(pa, pldist/*, pnow->GetPosition().GetDiffusion()*/);
//        if ((pldir > -mindir) && (pldir < mindir)) {
        if (fabs(pldir - dir) < mindir) {
            if (pret) {
                toplr2 = RelVectorTo(pa, pret->GetPosition());
                pldist2 = toplr2.GetDistance();
                // vratime toho co je blizsie
                if( pldist < pldist2) pret = pnow;
            }
            else {
                pret = pnow;
            }
        }

        LOGMSG(1, "NIDPLAYER %d: dir %lf, dist %lf  (mindir %lf)", i, pldir, pldist, mindir);
    }
    return pret;
}

// FIXME: len copy paste NearestFriendToBall 
CAgent *CEstimateLocalSituation::NearestOpponentToBall(CLocalAgent *pa)
{
    CWorldModel *pwm = pa->GetWorldModel();
    Agents *pia = pwm->GetIdentifiedAgents();

    int i;
    C2DVector toplr, toplr2;
    double mindist;
    CAgent *pnow = NULL;
    CAgent *pret = NULL;

    ESide myside = pa->GetPlayerSide();

    C2DVector ballpos = pa->GetWorldModel()->GetBall()->GetPosition();
    C2DVector toball = RelVectorTo(pa, ballpos);

    mindist = MAX_DISTANCE;
    pret = NULL;

    double distplr2ball;

    // hladame medzi identifikovanymi hracmi
	for(i=0; i < pia->size(); i++)
	{
        pnow = pia->at(i);
        if ((!pnow->IsValid(pa->GetTime())) || (pnow->GetPlayerSide() == myside) ) continue;

        // vektor na hraca
        toplr = RelVectorTo(pa, pnow->GetPosition());
        
        distplr2ball = (toball - toplr).GetDistance();
        
        if (distplr2ball < mindist) {
            pret = pnow;
            mindist = distplr2ball;
        }
    }

    return pret;
}

CAgent *CEstimateLocalSituation::FreestFriend(CLocalAgent *pa)
{
    CWorldModel *pwm = pa->GetWorldModel();
    Agents *pia = pwm->GetIdentifiedAgents();
    int i;
    CAgent *pnow = NULL;
    CAgent *pret = NULL;

	ESide myside = pa->GetPlayerSide();

	double dClosestOpp, dMinimum = MAX_DISTANCE;

    // hladame medzi identifikovanymi hracmi
	for(i=0; i < pia->size(); i++)
	{
        pnow = pia->at(i);
        if (pnow->GetPlayerSide() == myside) {
			dClosestOpp = DistToClosestOpponent(pa, pnow->GetPosition());
			if (dClosestOpp <= dMinimum) {
				dMinimum = dClosestOpp;
				pret = pnow;
			}
        }
    }

    return pret;

}

bool CEstimateLocalSituation::BallCatchable(CLocalAgent *pa)
{    
    if (pa->m_last_catch + pa->cfg->catch_ban_cycle > pa->GetTime())
    {
        return false;
    }
        
    // a zistit ci sa moze chytat - da sa iba raz za nejaky cas
    C2DVector toball = RelVectorTo(pa, pa->GetWorldModel()->GetBall()->GetPosition());
    bool bCatchArea = toball.GetDistance() < pa->cfg->catchable_area_l;

    if (bCatchArea)
        pa->m_last_catch = pa->GetTime().m_nAllCycles;

    return bCatchArea;
//    // toto je ballkickable 
//    double disttoball = RelVectorTo(pa, pa->GetWorldModel()->GetBall()->GetPosition()).GetDistance();
//    double dist = (pa->cfg->kickable_area*2) - disttoball;
//    if (dist < 0) return false;
//    return true;
}

C2DVector CEstimateLocalSituation::BallPosition(CLocalAgent *pa, int nTime, C2DVector cNewBallSpeed)
{
    C2DVector cBallPos = pa->GetWorldModel()->GetBall()->GetPosition();

    // geometricky rad - postupne spomalovanie lopty
    double x;
    if (pa->cfg->ball_decay != 1)
        x = (pow(pa->cfg->ball_decay, (double)nTime) - 1) / (pa->cfg->ball_decay - 1);
    else
        x = nTime * pa->cfg->ball_decay;

    return cBallPos + cNewBallSpeed * x;
}

C2DVector CEstimateLocalSituation::BallPosition(CLocalAgent *pa, int nTime)
{
    C2DVector cBallPos = pa->GetWorldModel()->GetBall()->GetPosition();
    C2DVector cNewBallSpeed = pa->GetWorldModel()->GetBall()->GetSpeed();

/*
    double x;
    if (cfg->ball_decay != 1)
        x = (pow(cfg->ball_decay, (double)nTime) - 1) / (cfg->ball_decay - 1);
    else
        x = nTime * cfg->ball_decay;

    return cBallPos + cNewBallSpeed * x;
*/

	for(int i = 0; i < nTime; i++)
	{
		cBallPos += cNewBallSpeed;
        cNewBallSpeed *= pa->cfg->ball_decay;
	}

    return cBallPos;
}

C2DVector CEstimateLocalSituation::GetBallInterceptPosition(CLocalAgent *pa, C2DVector cNewBallSpeed, CAgent *pa2)
{
    C2DVector v(NOT_EXISTING, NOT_EXISTING);

    if (pa2 == NULL) pa2 = pa;

    // ratame s tym, ze sa musi najprv otocit do spravneho uhlu.
    // keby sa dalo nejako zistit ci sa musi otocit alebo nie, bolo by to presnejsie
    int nTurn = 1;

    // - ratanie polohy playera
    C2DVector cNewPos, cSpd, cAccel, cu;
//    cNewPos = pa->GetPosition();
    cNewPos.SetXY(0, 0);
    // FIX: accel
    // cAccel.SetAngle(pa->GetDirection());
    cSpd.SetXY(0,0);
//    cSpd = pa->GetSpeed();    // ked bude fungovat rychlost...
    // -


    for (int i=0; i < 32; i++)    // pokial to ma ist ???
    {
        // - ratanie polohy playera
        // FIX: accel
        cAccel.SetAngleDistance(0, pa->cfg->maxpower * pa->cfg->dash_power_rate); // todo: zapocitat staminu!
        // cAccel.SetDistance(cfg->maxpower * cfg->dash_power_rate); // todo: zapocitat staminu!
        if (cAccel.GetDistance() > pa->cfg->player_accel_max) cAccel.SetDistance(pa->cfg->player_accel_max);
        cu = cSpd + cAccel;
        cNewPos += cu;
        cSpd = cu * pa->cfg->player_decay;
        if (cSpd.GetDistance() > pa->cfg->player_speed_max) cSpd.SetDistance(pa->cfg->player_speed_max);
        // -

        // poloha lopty
        v = BallPosition(pa, i + nTurn, cNewBallSpeed);

        if (RelVectorTo(pa2, v).GetDistance() < cNewPos.GetDistance())
        {
            break;
        }

        // FIX: posledna poloha
//        v.SetXY(NOT_EXISTING, NOT_EXISTING);
    }



//    if (i<19) LOGMSG(1, "+time %d : disttoball %lf, howfaricanget %lf", i, RelVectorTo(pa, v).GetDistance(), cNewPos.GetDistance());

//    LOGMSG(1, "BallPos x:%lf, y:%lf", BallPosition(pa, 0).GetX(), BallPosition(pa, 0).GetY());
//    LOGMSG(1, "BallSpeed x:%lf, y:%lf", pa->GetWorldModel()->GetBall()->GetSpeed());
//    LOGMSG(1, "InterceptPos x:%lf, y:%lf", v.GetX(), v.GetY());

    return v;
}
CAgent *CEstimateLocalSituation::NearestPlayerToBall(CLocalAgent *pa)
{
    CWorldModel *pwm = pa->GetWorldModel();
    Agents *pia = pwm->GetIdentifiedAgents();

    int i;
    C2DVector toplr, toplr2;
    double mindist;
    CAgent *pnow = NULL;
    CAgent *pret = NULL;

    ESide myside = pa->GetPlayerSide();


    C2DVector ballpos = pa->bskl->GetBallInterceptPosition(pa, pa->GetWorldModel()->GetBall()->GetSpeed());
    C2DVector toball = RelVectorTo(pa, ballpos);

    mindist = MAX_DISTANCE;
    pret = NULL;

    double distplr2ball;

    // medzi identifikovanymi hracmi
	for(i=0; i < pia->size(); i++)
	{
        pnow = pia->at(i);
        // vektor na hraca
        toplr = RelVectorTo(pa, pnow->GetPosition());

        distplr2ball = (toball - toplr).GetDistance();

		if (distplr2ball < mindist) {
			pret = pnow;
			mindist = distplr2ball;
		}
    }

    return pret;
}

CAgent *CEstimateLocalSituation::NearestOppPlayer(CLocalAgent *pa)
{
    CWorldModel *pwm = pa->GetWorldModel();
    Agents *pia = pwm->GetIdentifiedAgents();

    int i;
	CDiffuse2DVector plrpos, plrspd;
    C2DVector toplr, toplr2;
    double mindist;
    CAgent *pnow = NULL;
    CAgent *pret = NULL;

    ESide myside = pa->GetPlayerSide();

    mindist = MAX_DISTANCE;
    pret = NULL;

    double distplr2me;

	for(i=0; i < pia->size(); i++)
	{
        pnow = pia->at(i);
        if (pnow->GetPlayerSide() != myside) {
            // predpokladany vektor na hraca v dalsom kroku
			// todo: pridat rychlost a smer kam bezi
			plrpos = pnow->GetPosition();

			toplr = RelVectorTo(pa, plrpos);
			
            distplr2me = toplr.GetDistance();

			if (distplr2me < mindist) {
				pret = pnow;
				mindist = distplr2me;
			}
        }
    }

    return pret;
}

CAgent *CEstimateLocalSituation::NearestUnitMemberToPlayer(CLocalAgent* pa, CAgent *a) 
{
    CWorldModel *pwm = pa->GetWorldModel();
    Agents *pia = pwm->GetIdentifiedAgents();

    int i, j;
    C2DVector toplr, tofriend;
    double mindist;
    CAgent *pnow = NULL;
    CAgent *pret = NULL;

	// zistim unit a velkost unitu pre pa
	int unitsize = pa->fskl->GetMyUnitSize(pa, pa->fskl->GetMyUnitType(pa, pa->GetPlayerNumber()));
	Pnum *unitmembers = pa->fskl->GetUnitMembers(pa, pa->fskl->GetMyUnitType(pa, pa->GetPlayerNumber()));

	// na ktorej strane hra pa
    ESide myside = pa->GetPlayerSide();

	// vektor od pa k protihtacovi
    toplr = RelVectorTo(pa, a->GetPosition());
    // ako je protihrac vzdialeny od pa
	mindist = toplr.GetDistance();
    pret = pa;

    double distplr2plr;

    // medzi identifikovanymi hracmi
	for(i=0; i < pia->size(); i++)
	{
		// je to spoluhrac
        if(myside == pia->at(i)->GetPlayerSide()) {
			pnow = pia->at(i);

			// je spoluhrac v mojom unite
			for(j = 0; j < unitsize; j++) {
				if(pnow->GetPlayerNumber() == unitmembers[j])
						break;
			}

			// ak je pozri ci nie je blizsie k hracovi
			if(j != unitsize) {

				// vektor na hraca
				tofriend = RelVectorTo(pa, pnow->GetPosition());

				distplr2plr = (toplr - tofriend).GetDistance();
			
				if (distplr2plr < mindist) {
					pret = pnow;
					mindist = distplr2plr;
				}
			}
		}
    }

    return pret;
	
}

CAgent *CEstimateLocalSituation::NearestFriendToPos(CLocalAgent *pa, C2DVector pos)
{
    CWorldModel *pwm = pa->GetWorldModel();
    Agents *pia = pwm->GetIdentifiedAgents();

    int i;
    C2DVector topos, toplr;
    double mindist;
    CAgent *pnow = NULL;
    CAgent *pret = NULL;

    ESide myside = pa->GetPlayerSide();

    topos = RelVectorTo(pa, pos);

    mindist = MAX_DISTANCE;
    pret = NULL;

    double distplr2pos;

    // hladame medzi identifikovanymi hracmi
	for(i=0; i < pia->size(); i++)
	{
        pnow = pia->at(i);
        if (pnow->GetPlayerSide() == myside) {
            // vektor na hraca
            toplr = RelVectorTo(pa, pnow->GetPosition());

            distplr2pos = (topos - toplr).GetDistance();

			if (distplr2pos < mindist) {
				pret = pnow;
				mindist = distplr2pos;
			}
        }
    }

    return pret;
}

CAgent *CEstimateLocalSituation::NearestUnitMemberToPos(CLocalAgent* pa, C2DVector pos) 
{
    CWorldModel *pwm = pa->GetWorldModel();
    Agents *pia = pwm->GetIdentifiedAgents();

    int i, j;
    C2DVector topos,tofriend;
    double mindist;
    CAgent *pnow = NULL;
    CAgent *pret = NULL;

	// zistim unit a velkost unitu pre pa
	int unitsize = pa->fskl->GetMyUnitSize(pa, pa->fskl->GetMyUnitType(pa, pa->GetPlayerNumber()));
	Pnum *unitmembers = pa->fskl->GetUnitMembers(pa, pa->fskl->GetMyUnitType(pa, pa->GetPlayerNumber()));

	// na ktorej strane hra pa
    ESide myside = pa->GetPlayerSide();

	// vektor od pa k protihtacovi
    topos = RelVectorTo(pa, pos);
    // ako je protihrac vzdialeny od pa
	mindist = topos.GetDistance();
    pret = pa;

    double distplr2pos;

    // medzi identifikovanymi hracmi
	for(i=0; i < pia->size(); i++)
	{
		// je to spoluhrac
        if(myside == pia->at(i)->GetPlayerSide()) {
			pnow = pia->at(i);

			// je spoluhrac v mojom unite
			for(j = 0; j < unitsize; j++) {
				if(pnow->GetPlayerNumber() == unitmembers[j])
						break;
			}

			// ak je pozri ci nie je blizsie k hracovi
			if(j != unitsize) {

				// vektor na hraca
				tofriend = RelVectorTo(pa, pnow->GetPosition());

				distplr2pos = (topos - tofriend).GetDistance();
			
				if (distplr2pos < mindist) {
					pret = pnow;
					mindist = distplr2pos;
				}
			}
		}
    }

    return pret;
	
}

C2DVector CEstimateLocalSituation::RelVectorTo(CAgent *pa, C2DVector pos)
{
    return Rot(pos - (C2DVector)pa->GetPosition(), -pa->GetDirection());
}

double CEstimateLocalSituation::MinimalDirection(CLocalAgent *pa, double dist)
{
    double dFix = 1;
    double s = (pa->cfg->player_size + dFix * pa->cfg->player_size) / dist;
    if (s <= 1) return asin(s);
    else        return DegToRad(90);
//    return asin(2 * dFix * cfg->player_size / dist);
}

double CEstimateLocalSituation::DistToClosestOpponent(CLocalAgent *pa, C2DVector cFriendPos)
{
	// todo: mozno by bolo dobre neidentifikovaneho playera chapat ako oponenta

	C2DVector tofriend = RelVectorTo(pa, cFriendPos);

    CWorldModel *pwm = pa->GetWorldModel();
    Agents *pia = pwm->GetIdentifiedAgents();
    int i;
    CAgent *pnow = NULL;
	double dOppDist, dRet = MAX_DISTANCE;

    ESide myside = pa->GetPlayerSide();

	for(i=0; i < pia->size(); i++)
	{
        pnow = pia->at(i);
        if (pnow->GetPlayerSide() != myside) {
			dOppDist = (RelVectorTo(pa, pnow->GetPosition()) - tofriend).GetDistance();
			if (dOppDist < dRet) dRet = dOppDist;
        }
    }
    return dRet;
}
