// Query.cpp: implementation of the CQuery class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "ruleparser.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

class CFact;

CQuery::CQuery()
{
	IXMLDOMDocumentPtr dom;
	IXMLDOMNodePtr e;
	_bstr_t s;
	_variant_t filename;
	_variant_t retval((bool) true);
	_variant_t v;

	IXMLDOMNodeListPtr l;
	IXMLDOMElementPtr el;

	dom.CreateInstance( "MSXML2.DOMDocument.3.0" );

	s = "facts.xml";
	filename.vt = VT_BSTR;
	filename.bstrVal = s;

	retval = dom->load( filename );
	
	if ( (bool)retval == false )
		return;

	e = dom->documentElement;

	l = e->selectNodes( L"fact" );

	l->reset();

	el = l->nextNode(); 

	while ( el )
	{
		CFact *r = new CFact;
		v.vt = VT_BSTR;

		el->attributes->getNamedItem( "name" )->get_nodeValue( &v );
		s = v.bstrVal;
		r->name = s;

		el->attributes->getNamedItem( "value" )->get_nodeValue( &v );
		s = v.bstrVal;
		r->value = s;

		m_facts.push_back( *r );

		el = l->nextNode(); 
	}

	e.Release();
	dom.Release();

	return;
}

CQuery::~CQuery()
{
	m_facts.clear();
}

string CQuery::getValue(string sVarName)
{
	string sRetVal;			
	TFactVectorIterator fi = m_facts.begin();
	TFactVectorIterator fe = m_facts.end();

	for ( ; fi != fe; fi++ )
	{
		CFact& f = *fi;
		if ( f.name == sVarName )
			return f.value;

	}

	return "";
}


