#include "stdafx.h"
#include "LogManager.h"
#include "WorldObjects.h"
#include "AbstractBasicSkills.h"

#define POWERRANGE(x)  (((x)>GetAgent()->cfg->maxpower)?GetAgent()->cfg->maxpower:             \
                        (((x)<GetAgent()->cfg->minpower)?GetAgent()->cfg->minpower:(x)))
#define MOMENTRANGE(x) (((x)>GetAgent()->cfg->maxmoment)?GetAgent()->cfg->maxmoment:           \
                        (((x)<GetAgent()->cfg->minmoment)?GetAgent()->cfg->minmoment:(x)))
#define NECKRANGE(x)   (((x)>GetAgent()->cfg->maxneckmoment)?GetAgent()->cfg->maxneckmoment:   \
                        (((x)<GetAgent()->cfg->minneckmoment)?GetAgent()->cfg->minneckmoment:(x)))

#define MINTURN  0.001

// FIXME: pre aku neurcitost sa pozerat za loptou
#define INVALID(diff, dist) ((((dist)>5) && ((diff)>(0.5*(dist)))) || (((dist)<5) && ((diff)>3)))
/////////////////////////////////////////////////////////////////////////////////////////////
CTurn::CTurn( TParamVector &parameter, CLocalAgent *pl, int priority   ) :CAbstractBasicSkills( BSKILL_MOVE, priority, pl ) 
{
	double posX = 0, posY = 0; m_accel = 0;
	m_accel = 0;
	TParamVectorIterator index = parameter.begin();
	for( ; index != parameter.end(); index++ ) {
		if( index->name == VALUE_X ) 
				sscanf( index->value.data(), "%lf", &posX ); 				
		if( index->name == VALUE_Y ) 
				sscanf( index->value.data(), "%lf", &posY );
		if( index->name == VALUE_ANGLE) 
				sscanf( index->value.data(), "%lf", &m_dir );
		if( index->name == VALUE_TYPE )
				sscanf( index->value.data(), "%d", &m_skillSkillType );			
	}
	m_pos = C2DVector( posX, posY ); 
}

void CTurn::Execute() 
{
	switch(	m_skillSkillType ) {
	case BSKILL_TURN_ME:
		Turn(m_moment);
		break;
	case BSKILL_TURN_TO:
		TurnTo(m_pos);
		break;
	case BSKILL_TURN_2:
		Turn2(m_moment);
		break;
	}	
}

void CTurn::Turn(  double moment)
{
    CGameCommand *pGameCommand = new CGameCommand();
    
    double moment2 = RadToDeg(AngNormalise(moment));
    moment2 = MOMENTRANGE(moment2);  
    
    if ((moment2<-MINTURN) || (moment2>MINTURN)) {
        pGameCommand->Turn(moment2);
        GetAgent()->actionseq->AddGameCommand(pGameCommand);
    } else {
        delete pGameCommand;
    }
}

double CTurn::TurnWantedToReal(  double angle)
{
    return angle / (1.0 + GetAgent()->cfg->inertia_moment * GetAgent()->GetSpeed().GetDistance());
}

double CTurn::TurnRealToWanted(  double moment)
{
    return moment * (1.0 + GetAgent()->cfg->inertia_moment * GetAgent()->GetSpeed().GetDistance());
}

void CTurn::TurnTo(  C2DVector pos)
{
    Turn2( m_localSituation->RelVectorTo(GetAgent(), pos).GetAngle());
}

void CTurn::Turn2(double angle)
{
    Turn(TurnRealToWanted( angle));
}

///////////////////////////////////CTurnNeck///////////////////////////////////////////

CTurnNeck::CTurnNeck( TParamVector &parameter, CLocalAgent *pl, int priority   ) :CAbstractBasicSkills( BSKILL_MOVE, priority, pl ) 
{
	double posX = 0, posY = 0; m_accel = 0;
	m_accel = 0;
	TParamVectorIterator index = parameter.begin();
	for( ; index != parameter.end(); index++ ) {
		if( index->name == VALUE_X ) 
				sscanf( index->value.data(), "%lf", &posX ); 				
		if( index->name == VALUE_Y ) 
				sscanf( index->value.data(), "%lf", &posY );
		if( index->name == VALUE_TYPE )
				sscanf( index->value.data(), "%d", &m_skillSkillType );			
	}
	m_pos = C2DVector( posX, posY ); 
}

void CTurnNeck::Execute() 
{
	switch(	m_skillSkillType ) {
	case BSKILL_TURN_NECK_BASIC:
		TurnNeck(m_moment);
		break;
	case BSKILL_TURN_NECK_TO:
		TurnNeckTo(m_pos);
		break;
	case BSKILL_TURN_NECK_TO_BALL:
		TurnNeckToBall();
		break;
	case BSKILL_TURN_NECK_STRAIGHT:
		TurnNeckStraight();
		break;
	}	
}

void CTurnNeck::TurnNeckStraight( )
{
    double neckang =  GetAgent()->GetDirection() - GetAgent()->GetNeckDirection();
    if ((neckang < DegToRad(-1.0)) || (neckang > DegToRad(1.0))) TurnNeck(neckang);
}

void CTurnNeck::TurnNeckToBall( )
{
    CBall *pBall = GetAgent()->GetWorldModel()->GetBall();
    CDiffuse2DVector vball = pBall->GetPosition() - GetAgent()->GetPosition();
    double necktoball = vball.GetAngle() - GetAgent()->GetNeckDirection();
    TurnNeck( necktoball);
}


void CTurnNeck::TurnNeckTo(  C2DVector pos)
// FIXME: ak urobim turn, tak turnneckto sa musi od toho odpocitat!!!
// FIXME: bude treba urobit kontrolu ci sa mozem az tam otocit
//        a pripadne orezat, nech pri recompute nepocitam s blbostami
{
    C2DVector necktopos = Rot(pos - (C2DVector)GetAgent()->GetPosition(), -GetAgent()->GetNeckDirection());
    TurnNeck(necktopos.GetAngle());

//    double n = - ( GetAgent()->GetNeckDirection() - GetAgent()->GetDirection() );
//    double n = GetAgent()->GetDirection();

//    double n = RelVectorTo(GetAgent(), pos).GetAngle() - GetAgent()->GetDirection();
//    n += Rot(pos - (C2DVector)GetAgent()->GetPosition(), -GetAgent()->GetNeckDirection()).GetAngle();

//    n+=DegToRad(10);

//    TurnNeck(GetAgent(), n);
}

void CTurnNeck::TurnNeck(  double moment)
{
    CGameCommand *pGameCommand = new CGameCommand();
    
    double moment2 = RadToDeg(AngNormalise(moment));  
    moment2 = NECKRANGE(moment2);  pGameCommand->TurnNeck(moment2);
    GetAgent()->actionseq->AddGameCommand(pGameCommand);
}
