#include "stdafx.h"
#include "LogManager.h"
#include "WorldObjects.h"
#include "AbstractBasicSkills.h"

#define POWERRANGE(x)  (((x)>GetAgent()->cfg->maxpower)?GetAgent()->cfg->maxpower:             \
                        (((x)<GetAgent()->cfg->minpower)?GetAgent()->cfg->minpower:(x)))
#define MOMENTRANGE(x) (((x)>GetAgent()->cfg->maxmoment)?GetAgent()->cfg->maxmoment:           \
                        (((x)<GetAgent()->cfg->minmoment)?GetAgent()->cfg->minmoment:(x)))
#define NECKRANGE(x)   (((x)>GetAgent()->cfg->maxneckmoment)?GetAgent()->cfg->maxneckmoment:   \
                        (((x)<GetAgent()->cfg->minneckmoment)?GetAgent()->cfg->minneckmoment:(x)))

#define MINTURN  0.001

// FIXME: pre aku neurcitost sa pozerat za loptou
#define INVALID(diff, dist) ((((dist)>5) && ((diff)>(0.5*(dist)))) || (((dist)<5) && ((diff)>3)))


void CKick::Execute() 
{
	switch( m_skillSkillType ) 
	{
	case BSKILL_KICK_WITH_POWER:
		Kick( m_power, m_dir );	
		break;
	case BSKILL_KICK_WITH_ACCEL: 
		Kick2( m_accel, m_dir );
		break;
	case BSKILL_KICK_WITH_ACCEL_BYPASS: 
		Kick2Bypass( m_pos, m_accel);
		break;
	case BSKILL_KICK_TO_POSITION:
		KickTo(m_pos, m_accel);
		break;
	case BSKILL_KICK_GOAL:
		GoalKick();				
		break;
	case BSKILL_KICK_FRIENDKICK: 
		FriendKick();
		break;
	}
}


//------------------------------------------------------
/*! \fn	CKick::CKick( TParameterBSkillsVector &parameter, CLocalAgent *pl, int priority  ) :CAbstractBasicSkills( BSKILL_KICK, priority, pl ) 
 *  \brief rozhranie s vektorom parametrov
 *  \param  TParameterBSkillsVector &parameter
 *  \param  CLocalAgent *pl
 *  \param  int priority 
 *  \return
 *  \author Rado Otipka 
 *  \date 4. 12. 2001 20:09:33

 *  \bug 
 */
//------------------------------------------------------
// Historia zmien:
//------------------------------------------------------
/*
 */
//------------------------------------------------------
CKick::CKick( TParamVector &parameter, CLocalAgent *pl, int priority  ) :CAbstractBasicSkills( BSKILL_KICK, priority, pl ) 
{
	double posX = 0, posY = 0; m_accel = 0;
	m_accel = 0;
	TParamVectorIterator index = parameter.begin();
	for( ; index != parameter.end(); index++ ) {
		if( index->name == VALUE_X ) 
				sscanf( index->value.data(), "%lf", &posX ); 				
		if( index->name == VALUE_Y ) 
				sscanf( index->value.data(), "%lf", &posY );
		if( index->name == VALUE_ACCEL )
				sscanf( index->value.data(), "%lf", &m_accel );
		if( index->name == VALUE_TYPE )
				sscanf( index->value.data(), "%d", &m_skillSkillType );			
	}
	m_pos = C2DVector( posX, posY ); 
};

void CKick::Kick(  double power, double dir)
{
    CGameCommand *pGameCommand = new CGameCommand();
    
    pGameCommand->Kick(POWERRANGE(power), RadToDeg(AngNormalise(dir)));
    GetAgent()->actionseq->AddGameCommand(pGameCommand);
}

double CKick::KickDistance()
{

	// zavisi od maxpower*kickwantedtoreal*...

    return 20;
}

void CKick::Kick2(  double accel, double dir)
{
    // treba dat pozor aby sme nekopli do seba (prip. do ineho hraca???)

    // treba zapocitat rychlost lopty + natocenie
    C2DVector vkick = KickRealToWanted( accel, dir);
    Kick(vkick.GetDistance(), vkick.GetAngle());

}

C2DVector CKick::KickRealToWanted(  double accel, double dir)
{
    // treba zapocitat rychlost lopty + natocenie
    CBall *pBall = GetAgent()->GetWorldModel()->GetBall();
    C2DVector vball = m_localSituation->RelVectorTo(GetAgent(), pBall->GetPosition());
    double dist_ball = vball.GetDistance();
    double dir_diff = fabs(RadToDeg(vball.GetAngle()));
    double factor = GetAgent()->cfg->kick_power_rate * (1.0 - 0.25 * dir_diff / 180.0 - 0.25 * (dist_ball - GetAgent()->cfg->player_size - GetAgent()->cfg->ball_size) / GetAgent()->cfg->kickable_margin);

    C2DVector vkick;
    vkick.SetAngleDistance(dir, accel);
//    vkick -= pBall->GetSpeed();
	vkick.SetDistance(vkick.GetDistance() / factor);
	return vkick;
}

C2DVector CKick::KickWantedToReal(  double accel, double dir)
{
    // treba zapocitat rychlost lopty + natocenie
    CBall *pBall = GetAgent()->GetWorldModel()->GetBall();
    C2DVector vball = m_localSituation->RelVectorTo(GetAgent(), pBall->GetPosition());
    double dist_ball = vball.GetDistance();
    double dir_diff = fabs(RadToDeg(vball.GetAngle()));
    double factor = GetAgent()->cfg->kick_power_rate * (1.0 - 0.25 * dir_diff / 180.0 - 0.25 * (dist_ball - GetAgent()->cfg->player_size - GetAgent()->cfg->ball_size) / GetAgent()->cfg->kickable_margin);

    C2DVector vkick;
    vkick.SetAngleDistance(dir, accel);
	vkick.SetDistance(vkick.GetDistance() * factor);
//    vkick += pBall->GetSpeed();
	return vkick;
}

void CKick::KickTo(  C2DVector pos, double accel)
{
    // vektor od lopty k pozicii kam treba strelit
    C2DVector v = pos - (C2DVector)GetAgent()->GetWorldModel()->GetBall()->GetPosition();
    // uhol relativne k hracovemu natoceniu
    double ang = v.GetAngle() - GetAgent()->GetDirection();

    if (accel==0) {
        // vypocet accel zo vzdialenosti pos aby tam lopta akurat prisla
        // accel = |vektor_k_pos - vektor_k_lopte|
        accel = v.GetDistance() * (1 - GetAgent()->cfg->ball_decay ) + 0.1;

	}
    else {
        // inac dame silu taku ako bola zadana rychlost
        accel = KickWantedToReal(accel, ang).GetDistance();
    }
    
    Kick2( accel, ang);
}


void CKick::GoalKick()
{
    CAgent *pAgent = NULL;

    ESide tMySide = GetAgent()->GetPlayerSide();
    Agents *pIAgents = GetAgent()->GetWorldModel()->GetIdentifiedAgents();

    // pripravime si vektor rychlosti lopty -> tym budeme strielat
    CAngular2DVector cBallSpeed(0, GetAgent()->cfg->ball_speed_max);

    int i, j, nNTestDir = 0;
    double aTestDir[MAXNTESTDIR], dir;
    double dMinDir = -PI/2, dMaxDir = +PI/2;
    C2DVector pos;

    pos = GetAgent()->field->GetGoal(GT_R) + C2DVector(0, GetAgent()->cfg->goal_width*3/7);
    dir = AngNormalise((pos - GetAgent()->GetPosition()).GetAngle());
    aTestDir[nNTestDir++] = dir;  dMaxDir = dir;

    pos = GetAgent()->field->GetGoal(GT_R) + C2DVector(0, -GetAgent()->cfg->goal_width*3/7);
    dir = AngNormalise((pos - GetAgent()->GetPosition()).GetAngle());
    aTestDir[nNTestDir++] = dir;  dMinDir = dir;


    // daj do pola smery k vsetkym cudzym hracom
    for(i=0; i < pIAgents->size(); i++) {
        pAgent = pIAgents->at(i);
        if ((!pAgent->IsValid(GetAgent()->GetTime())) || (pAgent->GetPlayerSide() == tMySide)) continue;

        dir = AngNormalise((pAgent->GetPosition() - GetAgent()->GetPosition()).GetAngle());
        if ((dir > dMinDir) && (dir < dMaxDir))
            aTestDir[nNTestDir++] = dir;

        if (nNTestDir >= MAXNTESTDIR) break;
    }

    // bubble sort :)
    bool change;
    do {
        change = false;
        for(i=0; i < nNTestDir-1; i++)
            if (aTestDir[i]>aTestDir[i+1]) { dir=aTestDir[i]; aTestDir[i]=aTestDir[i+1]; aTestDir[i+1]=dir; change=true; }
    } while (change);
        
    // stredne hodnoty
    for(i=0; i < nNTestDir-1; i++)
        aTestDir[i] = (aTestDir[i] + aTestDir[i+1])/2;
    nNTestDir--;
    
    double dBestDir = 0, dBestDist = 0;
    C2DVector cIntrPos;
	for(i = 0; i < nNTestDir; i++)
	{
        cBallSpeed.SetAngle(aTestDir[i]);

        double dMinDist = MAX_DISTANCE;
        for(j=0; j < pIAgents->size(); j++) {
            pAgent = pIAgents->at(j);
            if ((!pAgent->IsValid(GetAgent()->GetTime())) || (pAgent->GetPlayerSide() == tMySide)) continue;

            cIntrPos = GetAgent()->bskl->GetBallInterceptPosition(GetAgent(), cBallSpeed, pAgent) - GetAgent()->GetPosition();
            if (dMinDist > cIntrPos.GetDistance())
                dMinDist = cIntrPos.GetDistance();
            
        }
        // hladame smer s najvacsou vzdialenostou k najskorsiemu chyteniu lopty
        if (dBestDist < dMinDist) {
            dBestDist = dMinDist;
            dBestDir = aTestDir[i];
        }
    }

    GetAgent()->bskl->Kick(GetAgent(), 100.0, dBestDir - GetAgent()->GetNeckDirection());
}


void CKick::FriendKick()
{
    CAgent *pAgent = NULL;

    ESide tMySide = GetAgent()->GetPlayerSide();
    Agents *pIAgents = GetAgent()->GetWorldModel()->GetIdentifiedAgents();

    // pripravime si vektor rychlosti lopty -> tym budeme strielat
    CAngular2DVector cBallSpeed(0, GetAgent()->cfg->ball_speed_max);

    int i, j, nNTestDir = 0;
    double aTestDir[MAXNTESTDIR], dir;
    // nahravaj len dopredu!!
    double dMinDir = -PI/2, dMaxDir = +PI/2;
    C2DVector pos;

    dir = AngNormalise((GetAgent()->field->GetGoal(GT_R) - GetAgent()->GetPosition()).GetAngle());
    dMinDir = dir - PI/2;  dMaxDir = dir + PI/2;


/*
    pos = GetAgent()->field->GetGoal(GT_R) + C2DVector(0, GetAgent()->cfg->goal_width*3/7);
    dir = AngNormalise((pos - GetAgent()->GetPosition()).GetAngle());
    aTestDir[nNTestDir++] = dir;  dMaxDir = dir;

    pos = GetAgent()->field->GetGoal(GT_R) + C2DVector(0, -GetAgent()->cfg->goal_width*3/7);
    dir = AngNormalise((pos - GetAgent()->GetPosition()).GetAngle());
    aTestDir[nNTestDir++] = dir;  dMinDir = dir;
*/

    // daj do pola smery k vsetkym superom
    for(i=0; i < pIAgents->size(); i++) {
        pAgent = pIAgents->at(i);
        if ((!pAgent->IsValid(GetAgent()->GetTime())) || (pAgent->GetPlayerSide() == tMySide)) continue;

        C2DVector cToOpp = (pAgent->GetPosition() - GetAgent()->GetPosition());
        // vyhod tych, co su moc daleko
        if (cToOpp.GetDistance() > GetAgent()->cfg->field_length/3) continue;

        dir = AngNormalise(cToOpp.GetAngle());
        if ((dir > dMinDir) && (dir < dMaxDir))
            aTestDir[nNTestDir++] = dir;

        if (nNTestDir >= MAXNTESTDIR) break;
    }

    // bubble sort :)
    bool change;
    do {
        change = false;
        for(i=0; i < nNTestDir-1; i++)
            if (aTestDir[i]>aTestDir[i+1]) { dir=aTestDir[i]; aTestDir[i]=aTestDir[i+1]; aTestDir[i+1]=dir; change=true; }
    } while (change);
        
    // stredne hodnoty => medzi superov skusime
    for(i=0; i < nNTestDir-1; i++)
        aTestDir[i] = (aTestDir[i] + aTestDir[i+1])/2;
    nNTestDir--;

    // aj smer priamo na branku tam dame
    dir = AngNormalise((GetAgent()->field->GetGoal(GT_R) - GetAgent()->GetPosition()).GetAngle());
    if ((dir > dMinDir) && (dir < dMaxDir))
            aTestDir[nNTestDir++] = dir;

    double dBestDir = dir, dBestDist = 0;
    
   // daj do pola smery k vsetkym nasim hracom
    for(i=0; i < pIAgents->size(); i++) {
        pAgent = pIAgents->at(i);
        if ((!pAgent->IsValid(GetAgent()->GetTime())) || (pAgent->GetPlayerSide() != tMySide)) continue;

        C2DVector cToMy = (pAgent->GetPosition() - GetAgent()->GetPosition());
        // vyhod tych, co su moc daleko
        if (cToMy.GetDistance() > GetAgent()->cfg->field_length/2) continue;

        dir = AngNormalise(cToMy.GetAngle());
        if ((dir > dMinDir) && (dir < dMaxDir))
            aTestDir[nNTestDir++] = dir;

        if (nNTestDir >= MAXNTESTDIR) break;
    }
    
    C2DVector cIntrPos;
	for(i = 0; i < nNTestDir; i++)
	{
        cBallSpeed.SetAngle(aTestDir[i]);

        // najblizsi opponent
        double dMinDistOpp = MAX_DISTANCE;
        for(j=0; j < pIAgents->size(); j++) {
            pAgent = pIAgents->at(j);
            if ((!pAgent->IsValid(GetAgent()->GetTime())) || (pAgent->GetPlayerSide() == tMySide)) continue;

            cIntrPos = GetAgent()->bskl->GetBallInterceptPosition(GetAgent(), cBallSpeed, pAgent) - GetAgent()->GetPosition();
            // ani super ich nechyti
            if ((cIntrPos.GetDistance() > 5) && (dMinDistOpp > cIntrPos.GetDistance()))
                dMinDistOpp = cIntrPos.GetDistance();
        }

        // najblizsi spoluhrac - zacneme od seba (mozno to bude driblovat)
        double dMinDistMy = 
            (GetAgent()->bskl->GetBallInterceptPosition(GetAgent(), cBallSpeed)).GetDistance();
        for(j=0; j < pIAgents->size(); j++) {
            pAgent = pIAgents->at(j);
            if ((!pAgent->IsValid(GetAgent()->GetTime())) || (pAgent->GetPlayerSide() != tMySide)) continue;

            cIntrPos = GetAgent()->bskl->GetBallInterceptPosition(GetAgent(), cBallSpeed, pAgent) - GetAgent()->GetPosition();
            // prilis blizke nechytime
            if ((cIntrPos.GetDistance() > 5) && (dMinDistMy > cIntrPos.GetDistance()))
                dMinDistMy = cIntrPos.GetDistance();
        }

        // hladame smer s najvacsim pomerom vzdialenosti oponenta ku nasemu
        double dMinDist;

        if (dMinDistMy != 0)
            dMinDist = dMinDistOpp * dMinDistOpp / dMinDistMy;
        else 
            dMinDist = MAX_DISTANCE;

        if (dBestDist < dMinDist) {
            dBestDist = dMinDist;
            dBestDir = aTestDir[i];
        }
    }

  //GetAgent()->bskl->Kick(GetAgent(), 100.0, dBestDir - GetAgent()->GetNeckDirection());
}


void CKick::Kick2Bypass(C2DVector pos, double accel)
{
    CWorldModel *wModel =  GetAgent()->GetWorldModel();
	int agentsCount = wModel->GetIdentifiedAgentsCount();
	C2DVector v = pos - (C2DVector)GetAgent()->GetWorldModel()->GetBall()->GetPosition();
	for( int i=0; i< agentsCount; i++) {
		CAgent *agent = wModel->GetIdentifiedAgent(i);	
		C2DVector vector = agent->GetPosition();
		if( fabs(vector.GetY() - v.GetY()) < 7 ) {
			if(vector.GetY() > 0)
				v.m_y -= 15;
			else 
				v.m_y += 15;
		}	else 
			if( fabs(vector.GetX() - v.GetX())< 7 ) {
			if(vector.GetX() > 0)
				v.m_x -= 15;
			else 
				v.m_x += 15;
			
			}
	}	
	// uhol relativne k hracovemu natoceniu
    double ang = v.GetAngle() - GetAgent()->GetDirection();

    if (accel==0) {
        // vypocet accel zo vzdialenosti pos aby tam lopta akurat prisla
        // accel = |vektor_k_pos - vektor_k_lopte|
        accel = v.GetDistance() * (1 - GetAgent()->cfg->ball_decay ) + 0.1;

	}
    else {
        // inac dame silu taku ako bola zadana rychlost
        accel = KickWantedToReal(accel, ang).GetDistance();
    }  
    Kick2( accel, ang);
} 